import React from 'react'
import Pane from './Pane'
import SyntaxHighlighter from 'react-syntax-highlighter'
import { docco } from 'react-syntax-highlighter/dist/styles'
import theme from './theme'

const segmentStyle = {
  ...docco,
  hljs: {
    ...docco.hljs,
    background: 'transparent',
    padding: '0'
  }
}

const CodeBlock = ({ children, codeStyle, language, style, ...props }) =>
  <Pane textAlign='left' tint rounded padding={3} border textStyle='mono' style={{ overflowX: 'auto', ...style }}{...props}>
    <SyntaxHighlighter language={language} style={codeStyle}>{children}</SyntaxHighlighter>
  </Pane>

CodeBlock.propTypes = {
  ...Pane.propTypes,
  ...SyntaxHighlighter.propTypes
}

CodeBlock.defaultProps = {
  language: 'javascript',
  codeStyle: segmentStyle,
  theme
}

export default CodeBlock
