import React, { PropTypes } from 'react'
import styled, { css } from 'styled-components'

const styles = ({
  transform
}) => css`
  ${transform ? `transform: ${transform};` : ''}
`

const withTransform = (Comp) => {
  const TransformComp = styled(({
    transform,
    ...props
  }) => React.createElement(Comp, props))`${styles}`

  TransformComp.propTypes = {
    ...Comp.propTypes,
    transform: PropTypes.string
  }

  TransformComp.displayName = Comp.displayName

  return TransformComp
}

export {
  withTransform
}
